/*
 * udisk.c
 *
 *  Created on: Apr 2, 2024
 *      Author: Eagle
 */
#include "CH58x_common.h"
#include "usbfs_device.h"
#include "SW_UDISK.h"
#include "Internal_Flash.h"
#include "SPI_FLASH.h"
#include "CHRV3UFI.h"
#include "SPI_MSD_Driver.h"

extern MSD_CARDINFO cardInfo;
void udisk_init()
{
#if  FUN_UDISK
#if (STORAGE_MEDIUM == MEDIUM_SPI_FLASH)
    PRINT( "USBD UDisk Demo\r\nStorage Medium: SPI FLASH \r\n" );
    /* SPI flash init */
    FLASH_Port_Init( );
    /* FLASH ID check */
    FLASH_IC_Check( );
#elif (STORAGE_MEDIUM == MEDIUM_INTERAL_FLASH)      // Storage location is internal Flash
    PRINT( "USBD UDisk Demo\r\nStorage Medium: INTERNAL FLASH \r\n" );
    Flash_Sector_Count = IFLASH_UDISK_SIZE  / DEF_UDISK_SECTOR_SIZE;             // Number of Flash sectors: Internal Flash allocation space/size of each sector on the USB drive
    PRINT = DEF_UDISK_SECTOR_SIZE;                                   // Flash sector size
    LOG_INFO("Flash_Sector_Count:%d | Flash_Sector_Size:%d\r\n",Flash_Sector_Count,Flash_Sector_Size);
#elif (STORAGE_MEDIUM == MEDIUM_SDIO_TFCard)
    PRINT("USBFS UDisk Demo \r\nStorage Medium: SD Card \r\n");
//    while(SD_Init())
//    {
//        PRINT("SD Card Error!\r\n");
//        delay_ms(1000);
//    }
//    show_sdcard_info();
//    PRINT("SD Card OK\r\n");
//
//    Sector_Nums = ((u32)(SDCardInfo.CardCapacity>>20))/2;
//    PRINT("Sector_Nums:0x%08x\r\n", Sector_Nums);

    Flash_Sector_Size = cardInfo.BlockSize;                                           // TFCardС
    Flash_Sector_Count = cardInfo.Capacity/Flash_Sector_Size;
    /* Enable Udisk */
    Udisk_Capability = Flash_Sector_Count;
    Udisk_Status |= DEF_UDISK_EN_FLAG;              // USB drive status

    uint8_t state;
    /* USB Libs Initialization */
    PRINT( "UDisk library Initialization. \r\n" );
    state = CHRV3LibInit( );                        // Initialize the CHRV3 library, successful operation returns 0
    if(state == ERR_SUCCESS)
    {
        PRINT( "CHRV3 LIB Init SUCCESS\r\n");
    }
    CHRV3DiskStatus = DISK_MOUNTED;

    USBFS_Device_Init();
#endif
#endif
}
