/*
 * led_key.c
 *
 *  Created on: Feb 19, 2024
 *      Author: Eagle
 */
#include "CH58x_common.h"
#include "peripheral.h"
#include "HAL.h"

void peripheral_init()
{
    GPIOA_ModeCfg(TMR0_PWM,GPIO_ModeIN_Floating);
    //GPIOA_ModeCfg(TMR1_PWM,GPIO_ModeOut_PP_5mA);
    //GPIOA_ResetBits(TMR0_PWM);
    //GPIOA_ResetBits(TMR1_PWM);

    GPIOB_ModeCfg(SD_CD,GPIO_ModeIN_PU);
    peripheral_enable(PWR_EN_O, 1);

    led_init();
}

void peripheral_enable(uint32_t peripheral, uint8_t enable)
{
    GPIOB_ModeCfg(peripheral,GPIO_ModeOut_PP_5mA);
    if(enable){
        GPIOB_SetBits(peripheral);
    }else {
        GPIOB_ResetBits(peripheral);
    }
}

void led_init()
{
    GPIOB_ModeCfg(LED1,GPIO_ModeOut_PP_5mA);
    GPIOB_ModeCfg(LED2,GPIO_ModeOut_PP_5mA);

    PWMX_CLKCfg( 4 );                    // cycle = 4/Fsys
    PWMX_CycleCfg( PWMX_Cycle_256 );     // = 256*cycle
    PWMX_ACTOUT( CH_PWM8, 0, High_Level, ENABLE );
    PWMX_ACTOUT( CH_PWM9, 0, High_Level, ENABLE );

}
void led1_blink()
{
    static UINT8 duty = 0;
    static UINT32 lastTick = 0;

    if( 10000000 < ABS(SYS_GetSysTickCnt()-lastTick) )
    {
        lastTick = SYS_GetSysTickCnt();
        PWMX_ACTOUT( CH_PWM8, duty, High_Level, ENABLE );
        if(duty==0){
            duty = 50;
        }else {
            duty = 0;
        }
    }
}
